Attribute VB_Name = "GetWriteINIFile"
Option Explicit

'API-Funktionen deklarieren
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As Any, ByVal lsString As Any, ByVal lplFilename As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Function SaveINISetting(ByVal FileName As String, ByVal Key As String, ByVal Setting As String, ByVal Value As String)

   Call WritePrivateProfileString(Key, Setting, Value, FileName)

End Function

Public Function GetINISetting(ByVal FileName As String, ByVal Key As String, ByVal Setting As String, ByVal Default As Variant) As Variant

   Dim TEMP As String * 1024

   Call GetPrivateProfileString(Key, Setting, Default, TEMP, Len(TEMP), FileName)
   GetINISetting = Mid(TEMP, 1, InStr(1, TEMP, Chr(0)) - 1)

End Function
